/**
 * @file 构建逻辑
 * @author mj(zoumiaojiang@gmail.com)
 */

'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var path = require('path');
var fs = require('fs-extra');

var utils = require('../../lib/utils');
var log = require('../../lib/utils/log');
var locals = require('../../locals')();

/**
 * 处理 build 构建逻辑
 *
 * @param {string} config 用户指定的配置文件路径
 */
module.exports = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(config) {
        var rootDir, lavasConf, LavasCore, core;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        log.info(locals.START_BUILD + '...');

                        rootDir = utils.getLavasProjectRoot();

                        // 通过 package.json 中的配置将 lavas-core 从命令行解耦
                        // 要求所有的 core 都提供相同的 API

                        lavasConf = require(path.resolve(rootDir, 'package.json')).lavas || {};
                        LavasCore = require(lavasConf.core || 'lavas-core-vue');
                        core = new LavasCore(rootDir);

                        if (!config) {
                            _context.next = 12;
                            break;
                        }

                        if (!path.isAbsolute(config)) {
                            config = path.resolve(process.cwd(), config);
                        }

                        _context.next = 9;
                        return fs.pathExists(config);

                    case 9:
                        if (_context.sent) {
                            _context.next = 12;
                            break;
                        }

                        log.warn(`${locals.START_NO_FILE} ${config}`);
                        return _context.abrupt('return');

                    case 12:
                        _context.next = 14;
                        return core.init(process.env.NODE_ENV || 'production', true, { config });

                    case 14:
                        _context.next = 16;
                        return core.build();

                    case 16:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function (_x) {
        return _ref.apply(this, arguments);
    };
}();