/**
 * @file cli entry
 * @author mj(zoumiaojiang@gmail.com)
 */

'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var program = require('commander');
var exec = require('mz/child_process').exec;

var log = require('../lib/utils/log');
var checkUpdate = require('../lib/utils/checkUpdate');
var initCommand = require('./scaffold');
var buildCommand = require('./build');
var serverCommand = require('./server');
var locals = require('../locals')();

var version = process.env.VERSION || require('../../package.json').version;

// check the latest version
checkUpdate().then((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var output, argv;
    return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    if (process.argv[2]) {
                        _context.next = 7;
                        break;
                    }

                    _context.next = 3;
                    return exec('lavas -h');

                case 3:
                    output = _context.sent;

                    console.log(output[0]);
                    _context.next = 9;
                    break;

                case 7:
                    argv = process.argv[2];


                    if (argv === '-v' || argv === '--version') {
                        log.info('version: ', version);
                    }

                case 9:

                    // define lavas command
                    program.usage('[commands] [options]').arguments('<cmd> [env]').option('-v, --version', locals.SHOW_VERSION).action(function (cmd, env) {
                        if (env) {
                            log.error(`\`lavas ${cmd} ${env}\` ${locals.NO_COMMAND}`);
                        } else {
                            log.error('`lavas ' + cmd + '` ' + locals.NO_COMMAND);
                        }

                        log.info(locals.PLEASE_SEE + ' `lavas --help`');
                    });

                    initCommand(program);
                    buildCommand(program);
                    serverCommand(program);

                    program.parse(process.argv);

                case 14:
                case 'end':
                    return _context.stop();
            }
        }
    }, _callee, undefined);
})));