/**
 * @file lavas init scaffold action
 * @author mj(zoumiaojiang@gmail.com)
 */

'use strict';

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/**
 * export lavas project
 *
 * @param  {Object} params params for export action
 * @param  {Object} templateConf  the config content of project
 */
var exportProject = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(params, templateConf) {
        var spinner;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        spinner = ora(locals.LOADING_EXPORT_PROJECT + '...');


                        spinner.start();
                        _context.next = 4;
                        return lavasScaffold.render(params, templateConf);

                    case 4:
                        spinner.stop();

                        // for log beautify
                        console.log('');
                        log.info(locals.INIT_SUCCESS);
                        log.info(locals.INIT_NEXT_GUIDE + '：\n\n' + log.chalk.green('cd ' + params.name + '\n' + 'npm install\n' + 'lavas dev'));
                        _context.prev = 8;
                        _context.next = 11;
                        return axios('https://lavas.baidu.com/api/logger/send?action=cli&commander=init');

                    case 11:
                        _context.next = 15;
                        break;

                    case 13:
                        _context.prev = 13;
                        _context.t0 = _context['catch'](8);

                    case 15:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[8, 13]]);
    }));

    return function exportProject(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

/**
 * the entry of init pwa project
 *
 * @param {Object} conf  init config object
 */


function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var inquirer = require('inquirer');
var shelljs = require('shelljs');
var ora = require('ora');
var path = require('path');
var fs = require('fs-extra');
var axios = require('axios');

var formQ = require('./formQuestion');
var log = require('../../lib/utils/log');
var lavasScaffold = require('../../lib/scaffold');
var utils = require('../../lib/utils');
var locals = require('../../locals')();

var cwd = process.cwd();module.exports = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(conf) {
        var isNetworkOk, spinner, metaSchema, metaParams, templateConf, schema, params, projectTargetPath, isPathExist, ret;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.next = 2;
                        return utils.isNetworkConnect();

                    case 2:
                        isNetworkOk = _context2.sent;

                        if (isNetworkOk) {
                            _context2.next = 7;
                            break;
                        }

                        log.info(locals.NETWORK_DISCONNECT);
                        log.info(locals.NETWORK_DISCONNECT_SUG);
                        return _context2.abrupt('return');

                    case 7:
                        if (shelljs.which('git')) {
                            _context2.next = 11;
                            break;
                        }

                        log.info(locals.NO_GIT_COMMAND);
                        log.info(locals.NO_GIT_COMMAND_SUG);
                        return _context2.abrupt('return');

                    case 11:

                        log.info(locals.WELECOME);
                        log.info(locals.GREETING_GUIDE + '\n');

                        // 6 steps for init process

                        // 第一步：从云端配置获取 Meta 配置，确定将要下载的框架和模板 List
                        spinner = ora(locals.LOADING_FROM_CLOUD + '...');

                        spinner.start();
                        _context2.next = 17;
                        return lavasScaffold.getMetaSchema();

                    case 17:
                        metaSchema = _context2.sent;

                        spinner.stop();

                        // 第二步：等待用户选择将要下载的框架和模板
                        _context2.next = 21;
                        return formQ(metaSchema);

                    case 21:
                        metaParams = _context2.sent;


                        // 第三步：通过用户选择的框架和模板，下载模板
                        spinner.start();
                        _context2.next = 25;
                        return lavasScaffold.download(metaParams);

                    case 25:
                        templateConf = _context2.sent;

                        spinner.stop();

                        // 第四步：根据下载的模板的 meta.json 获取当前模板所需要用户输入的字段 schema
                        _context2.next = 29;
                        return lavasScaffold.getSchema(templateConf);

                    case 29:
                        schema = _context2.sent;
                        _context2.next = 32;
                        return formQ(schema);

                    case 32:
                        params = _context2.sent;


                        // 第六步：渲染模板，并导出到指定的文件夹(当前文件夹)
                        projectTargetPath = path.resolve(params.dirPath || cwd, params.name);

                        params = (0, _assign2.default)({}, metaParams, params);

                        _context2.next = 37;
                        return fs.pathExists(projectTargetPath);

                    case 37:
                        isPathExist = _context2.sent;

                        if (!isPathExist) {
                            _context2.next = 56;
                            break;
                        }

                        if (!conf.force) {
                            _context2.next = 46;
                            break;
                        }

                        _context2.next = 42;
                        return fs.remove(projectTargetPath);

                    case 42:
                        _context2.next = 44;
                        return exportProject(params, templateConf);

                    case 44:
                        _context2.next = 54;
                        break;

                    case 46:
                        _context2.next = 48;
                        return inquirer.prompt([{
                            'type': 'confirm',
                            'message': locals.SAMA_NAME_ENSURE + '?',
                            'default': false,
                            'name': 'isForce'
                        }]);

                    case 48:
                        ret = _context2.sent;

                        if (!ret.isForce) {
                            _context2.next = 54;
                            break;
                        }

                        _context2.next = 52;
                        return fs.remove(projectTargetPath);

                    case 52:
                        _context2.next = 54;
                        return exportProject(params, templateConf);

                    case 54:
                        _context2.next = 58;
                        break;

                    case 56:
                        _context2.next = 58;
                        return exportProject(params, templateConf);

                    case 58:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));

    return function (_x3) {
        return _ref2.apply(this, arguments);
    };
}();