'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file A simple meta info store
 * @author mj(zoumiaojiang@gmail.com)
 */

var requestP = require('request-promise');

var store = require('./store');
var conf = require('./config');

// 如果是开发环境就使用开发环境的 CONF 数据，避免污染线上的 CONF 数据
var confUrl = conf.GLOBAL_CONF_URL[process.env.NODE_ENV === 'development' ? 'development' : 'production'];

/**
 * 请求全局的配置 JOSN 数据
 *
 * @return {Object}   JSON 数据
 */
module.exports = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var _this = this;

    var data, timer;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    data = store.get('data');

                    // 如果 store 中已经存在了，那 2s 后我们再去尝试更新一下是不是有最新的数据

                    if (!data) {
                        _context2.next = 4;
                        break;
                    }

                    timer = setTimeout((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                        var json;
                        return _regenerator2.default.wrap(function _callee$(_context) {
                            while (1) {
                                switch (_context.prev = _context.next) {
                                    case 0:
                                        _context.next = 2;
                                        return requestP.get({ uri: confUrl, json: true });

                                    case 2:
                                        json = _context.sent;


                                        store.set('data', json);
                                        clearTimeout(timer);

                                    case 5:
                                    case 'end':
                                        return _context.stop();
                                }
                            }
                        }, _callee, _this);
                    })), 2000);
                    return _context2.abrupt('return', data);

                case 4:
                    _context2.next = 6;
                    return requestP.get({ uri: confUrl, json: true });

                case 6:
                    data = _context2.sent;

                    store.set('data', data);

                    return _context2.abrupt('return', data);

                case 9:
                case 'end':
                    return _context2.stop();
            }
        }
    }, _callee2, this);
}));