'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/**
 * 获取导出的所有的 fields （包含 default 参数）
 *
 * @param  {Object} fields  传入的 fields
 * @param  {Obejct} templateConf    模版的配置
 * @return {Object}         输出的 fields
 */
var extendsDefaultFields = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var fields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var templateConf = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var defaultFields, schema;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        defaultFields = {};
                        _context.t0 = store.get('schema');

                        if (_context.t0) {
                            _context.next = 6;
                            break;
                        }

                        _context.next = 5;
                        return lavasSchema.getSchema(templateConf);

                    case 5:
                        _context.t0 = _context.sent;

                    case 6:
                        schema = _context.t0;


                        (0, _keys2.default)(schema).forEach(function (key) {
                            return defaultFields[key] = schema[key].default;
                        });

                        /* eslint-disable fecs-use-computed-property */
                        defaultFields.name = fields.name || 'lavas-pwa';
                        defaultFields.dirPath = path.resolve(process.cwd(), fields.dirPath || '', defaultFields.name);

                        return _context.abrupt('return', _.merge({}, defaultFields, fields));

                    case 11:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function extendsDefaultFields() {
        return _ref.apply(this, arguments);
    };
}();

/**
 * 获取元 Schema - 涉及模版下载的 Schema
 *
 * @return {Promise<*>}   Meta Schema
 */


function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file lavas scaffold entry
 * @author mj(zoumiaojiang@gmail.com)
 */

var path = require('path');

var _ = require('lodash');

var lavasSchema = require('./schema');
var lavasTemplate = require('./template');
var store = require('./store');exports.getMetaSchema = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    _context2.t0 = store.get('metaSchema');

                    if (_context2.t0) {
                        _context2.next = 5;
                        break;
                    }

                    _context2.next = 4;
                    return lavasSchema.getMetaSchema();

                case 4:
                    _context2.t0 = _context2.sent;

                case 5:
                    return _context2.abrupt('return', _context2.t0);

                case 6:
                case 'end':
                    return _context2.stop();
            }
        }
    }, _callee2, this);
}));

/**
 * 获取 Schema - 涉及模版渲染的 Schema
 *
 * @param {Object} templateConf 模版自己的配置
 * @return {Promise<*>}   Schema
 */
exports.getSchema = function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var templateConf = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        if (templateConf) {
                            _context3.next = 4;
                            break;
                        }

                        _context3.next = 3;
                        return lavasTemplate.download();

                    case 3:
                        templateConf = _context3.sent;

                    case 4:
                        return _context3.abrupt('return', lavasSchema.getSchema(templateConf));

                    case 5:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this);
    }));

    return function () {
        return _ref3.apply(this, arguments);
    };
}();

/**
 * 通过指定的 meta 参数下载模版，下载成功后返回模板的 Schema 信息
 *
 * @param {Object} metaParams 导出参数
 * @return {*} 下载的临时路径 或者 报错对象
 */
exports.download = function () {
    var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        var metaParams = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return extendsDefaultFields(metaParams);

                    case 2:
                        metaParams = _context4.sent;
                        _context4.next = 5;
                        return lavasTemplate.download(metaParams);

                    case 5:
                        return _context4.abrupt('return', _context4.sent);

                    case 6:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this);
    }));

    return function () {
        return _ref4.apply(this, arguments);
    };
}();

/**
 * 通过指定的参数渲染下载成功的模板
 *
 * @param {Object} params 导出参数
 * @param {Object} templateConf 模版的配置
 * @return {Promise<*>}   导出的结果
 */
exports.render = function () {
    var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var templateConf = arguments[1];
        return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        if (templateConf) {
                            _context5.next = 4;
                            break;
                        }

                        _context5.next = 3;
                        return lavasTemplate.download();

                    case 3:
                        templateConf = _context5.sent;

                    case 4:
                        _context5.next = 6;
                        return extendsDefaultFields(params, templateConf);

                    case 6:
                        params = _context5.sent;
                        _context5.next = 9;
                        return lavasTemplate.render(params);

                    case 9:
                        return _context5.abrupt('return', _context5.sent);

                    case 10:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, this);
    }));

    return function () {
        return _ref5.apply(this, arguments);
    };
}();

if (process.env.NODE_ENV === 'development') {
    console.log('Woow! You are in development!!!');
}