/**
 * @file 检测新版本
 * @author mj(zoumiaojiang@gmail.com)
 */

'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var requestPackageInfo = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var packageInfo, lastVersion, curVersion;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.prev = 0;
                        _context.next = 3;
                        return axios({
                            url: LAVAS_NPM_REGISTRY,
                            timeout: 1000
                        });

                    case 3:
                        packageInfo = _context.sent;
                        lastVersion = packageInfo.data['dist-tags'].latest;
                        curVersion = require('../../../package.json').version;


                        if (semver.gt(lastVersion, curVersion)) {
                            log.info(log.chalk.bold.yellow(locals.UPDATE_TIPS));
                        }
                        _context.next = 11;
                        break;

                    case 9:
                        _context.prev = 9;
                        _context.t0 = _context['catch'](0);

                    case 11:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[0, 9]]);
    }));

    return function requestPackageInfo() {
        return _ref.apply(this, arguments);
    };
}();

/**
 * 检测是否需要更新 Lavas 版本
 */


function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var semver = require('semver');
var axios = require('axios');
var log = require('./log');
var getHome = require('./index').getHome;
var fs = require('fs-extra');
var path = require('path');
var locals = require('../../locals')();

var LAVAS_NPM_REGISTRY = 'https://registry.npm.taobao.org/lavas';
var TIME_RANGE = 24 * 60 * 60 * 1000;

module.exports = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var updateCheckerInfoPath, updateCheckerInfo, dirname;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    updateCheckerInfoPath = path.resolve(getHome(), '.updateChecker.txt');

                    if (!fs.existsSync(updateCheckerInfoPath)) {
                        _context2.next = 9;
                        break;
                    }

                    updateCheckerInfo = fs.readFileSync(updateCheckerInfoPath, 'utf-8');

                    if (!(Date.now() - +updateCheckerInfo >= TIME_RANGE)) {
                        _context2.next = 7;
                        break;
                    }

                    _context2.next = 6;
                    return requestPackageInfo();

                case 6:
                    fs.writeFileSync(updateCheckerInfoPath, Date.now() + '');

                case 7:
                    _context2.next = 14;
                    break;

                case 9:
                    dirname = path.dirname(updateCheckerInfoPath);

                    fs.existsSync(dirname) && fs.mkdirpSync(dirname);
                    fs.writeFileSync(updateCheckerInfoPath, Date.now() + '');
                    _context2.next = 14;
                    return requestPackageInfo();

                case 14:
                case 'end':
                    return _context2.stop();
            }
        }
    }, _callee2, this);
}));